% *******************************************
% *                                         *
% * Thomas Hzard                           *
% *                                         *
% * TD AMEA - Mthodes de synthse sonore 1 *
% *                                         *
% *******************************************


% Script de synthse croise par la technique du vocodeur de phase

clear variables;
close all;


% 1. Rcupration des sons
% ************************

% Lecture des fichiers
[sound1,Fs1] = wavread('C_trumpet_A3.wav');
[sound2,Fs2] = wavread('song.wav');

% Mise  la mme longueur et en mono
Lmin = min(size(sound1,1),size(sound2,1));
x1 = mean(sound1(1:Lmin),2);
x2 = mean(sound2(1:Lmin),2);

% 2. Analyse TFCT
% ***************

[Xt1,c1] = tfct_analyse(x1);
[Xt2,c2] = tfct_analyse(x2);

% 3. Synthse croise
% *******************

Xt = Xt1.*Xt2;
y = tfct_synthese(Xt,c1*c2);

% 4. Ecoute et affichage des rsultats
% ************************************

soundsc(x1,Fs1);
soundsc(x2,Fs2);
soundsc(y,Fs1);

N = 1024;
figure(1);
[S1,F1,T1,P1] = spectrogram(x1,hanning(N),N/2,N*4,Fs1);
surf(T1,F1,10*log10(P1),'edgecolor','none'); axis tight; 
view(0,90);
ylim([0,8000]);
xlabel('Time (Seconds)'); ylabel('Hz');
figure(2);
[S2,F2,T2,P2] = spectrogram(x2,hanning(N),N/2,N*4,Fs2);
surf(T2,F2,10*log10(P2),'edgecolor','none'); axis tight; 
view(0,90);
ylim([0,8000]);
xlabel('Time (Seconds)'); ylabel('Hz');
figure(3);
[S,F,T,P] = spectrogram(y,hanning(N),N/2,N*4,Fs1);
surf(T,F,10*log10(P),'edgecolor','none'); axis tight; 
view(0,90);
ylim([0,8000]);
xlabel('Time (Seconds)'); ylabel('Hz');
